clear all;
close all force;
tic

%To make the program work you just need to change the link to the following files:
%Make sure that the name is correct. If you test the code on a different
%set of data than the one it was designed for, the interpretation might not
%be optimal and you might wanna change some parameters, especially the ones
%of the band pass filter.
donnee=load('C:\Users\Jan\Desktop\Image Log Project\Final program\6406!2-4sr_ubi_amplitude.txt');
depthlog=load('C:\Users\Jan\Desktop\Image Log Project\Final program\6406!2-4sr_ubi_depth.txt');


%%
i_bot=4000;
i_top=6000;
donnee=donnee(i_bot:i_top,:);

%if amplitudes are considered
max_donnee=max(max(donnee));
donnee=max_donnee*ones(size(donnee))-donnee;

%% Interpolation
lsamples=0.01;
depth=depthlog(i_bot,1):lsamples:depthlog(i_top,1);%defines the deth vector
depth=depth';
depthlog=depthlog(i_bot:i_top,:);
mat=interp1(depthlog,donnee,depth);%defines a new matrix with only the data we are interested in

I=3;
CMAX=30;
CMIN=min(min(donnee));
plot_marilyn_Statoil(mat,CMIN,CMAX,depth,I);


%% FFT
% parameters you can play on:
f0=5;           %lower cut-off frequency
f1=20;          %higher cut-off frequency

[N,M]=size(mat);% Samples
if isinteger(N/2)
    mat(N,:)=[];
    N=N-1;
end
DAT=zeros(N,M);         % Output matrix with processed data
dt=lsamples;            % Sampling interval
T=(N-1)*dt;             % Spatial Periode
t=0:dt:T;               % Space vector
df=1/dt;                % Frequency sampling interval
f=zeros(N,1);           % frequency vector
F=zeros(N,1);           % Filter in frequency domain


% Compute Fourier transform
A=fft(mat);

% Designs the Band-pass filter
% Positive frequencies
for k= 1:N/2+1
    f(k)=(k-1)/T;
    if(f(k)>=f0&&f(k)<=f1)
        F(k)=1.;
    else
        F(k)=0.;
    end
end
% Negative frequencies
for k= N:-1:N/2+2
    f(k)=(N-k+1)/T;
    if(f(k)>=f0&&f(k)<=f1)
        F(k)=1.;
    else
        F(k)=0.;
    end
    f(k)=-f(k);
end

% Apply filter
for k=1:M
    DAT(:,k)=F.*A(:,k);
end

% Transform back to time
dat=real(ifft(DAT));

CMAX=7;
CMIN=-3;
plot_marilyn_Statoil(dat,CMIN,CMAX,depth,I);

%%
K=3;
nn_group_max=90/100*M;

filtre=ones(1,20)/20;
filter_dat=filter2(filtre,dat);
plot_marilyn_Statoil(filter_dat,CMIN,CMAX,depth,I);

[group_donnee,n_group] = pre_edge( filter_dat , K , M ,N);

%% Edge mapping
nn_group_min=20;
found_frac=cell(1,200);
exp_frac=cell(3,n_group);

ef=0;
ff=0;
for i=1:n_group
    [i_group , j_group]=find(group_donnee==i);
    max_j=max(j_group);
    min_j=min(j_group);
    
    if (max_j-min_j)<nn_group_min
        group_donnee(i_group,j_group)=0;
    else
        nn_group=length(i_group);
        ind_group=zeros(nn_group,2);
        j=min_j;
        k=1;
        while j<max_j+1
            ii_group=find(j_group==j);
            nnn_group=length(ii_group);
            vec=zeros(nnn_group,1);
            for ii=1:nnn_group
                vec(ii,1)=dat(i_group(ii_group(ii)),j);
            end
            [~,ii_max]=max(vec);
            ind_group(k,1)=i_group(ii_group(ii_max));
            ind_group(k,2)=j;
            k=k+1;
            j=j+1;
        end
        
        if (max_j-min_j)>=nn_group_max
            ff=ff+1;
            found_frac{1,ff}=ind_group;
            found_frac{1,ff}(k:end,:)=[];
        else
            ef=ef+1;
            exp_frac{1,ef}=ind_group;
            exp_frac{1,ef}(k:end,:)=[];
        end
    end
end

mat_edge=zeros(N,M);
for i=1:ef
    n=length(exp_frac{1,i});
    for j=1:n
        mat_edge(exp_frac{1,i}(j,1),exp_frac{1,i}(j,2))=i;
    end
end
CMAX=ef;
CMIN=0;
plot_marilyn_Statoil(mat_edge,CMIN,CMAX,depth,I);

%% Regroup group of points together
n_free=5; %freedom of search

x=linspace(0,2*pi,M);
n_gap=20;
n_deriv=5;
if n_deriv > nn_group_min+1
    disp('n_deriv > nn_group_min+1');
end

for i=1:ef
    exp_frac{2,i}(1,1)=0;
    exp_frac{3,i}(1,1)=0;
end

n_first=10;
k=0;
for i=1:ef
    n=length(exp_frac{1,i});
    if exp_frac{2,i}==0 || exp_frac{3,i}==1
        k=k+1;
        exp_frac{2,i}=k;
    end
    vec_deriv=zeros(1,n_deriv);
    for j=1:n_deriv
        vec_deriv(1,n_deriv-j+1)=(exp_frac{1,i}(n-j+1,1)-exp_frac{1,i}(n-j,1))/(exp_frac{1,i}(n-j+1,2)-exp_frac{1,i}(n-j,2));
    end
    deriv=mean(vec_deriv);
    
    if M-exp_frac{1,i}(n,2)<n_gap
        n_gap_loop=M-exp_frac{1,i}(n,2);
    else
        n_gap_loop=n_gap;
    end
    
    for ii=1:n_gap_loop
        i_deriv=round(mean(deriv)*ii);
        if exp_frac{1,i}(n,1)+i_deriv-n_free < 1
            i_vec_bot=1;
        else
            i_vec_bot=exp_frac{1,i}(n,1)+i_deriv-n_free;
        end
        if exp_frac{1,i}(n,1)+i_deriv+n_free > N
            i_vec_top=N;
        else
            i_vec_top=exp_frac{1,i}(n,1)+i_deriv+n_free;
        end
        
        vec=mat_edge(i_vec_bot:i_vec_top,exp_frac{1,i}(n,2)+ii);
        vec=(vec>0);
        
        i_vec=find(vec);
        if sum(vec)==1
            if exp_frac{1,i}(n,1)+i_deriv-n_free < 1
                i_vec=i_vec-(exp_frac{1,i}(n,1)+i_deriv-n_free)+1;
            end
            i_min=min(exp_frac{1,mat_edge(exp_frac{1,i}(n,1)+i_deriv+i_vec-n_free-1,exp_frac{1,i}(n,2)+ii)}(:,1));
            if exp_frac{2,mat_edge(exp_frac{1,i}(n,1)+i_deriv+i_vec-n_free-1,exp_frac{1,i}(n,2)+ii)}==0 && exp_frac{1,i}(n,2)+ii < i_min + n_first
                exp_frac{2,mat_edge(exp_frac{1,i}(n,1)+i_deriv+i_vec-n_free-1,exp_frac{1,i}(n,2)+ii)}=exp_frac{2,i};
            else
                exp_frac{3,mat_edge(exp_frac{1,i}(n,1)+i_deriv+i_vec-n_free-1,exp_frac{1,i}(n,2)+ii)}=1;
            end
            break
        end
    end
end
mat_edge=zeros(N,M);
for i=1:ef
    n=length(exp_frac{1,i});
    for j=1:n
        mat_edge(exp_frac{1,i}(j,1),exp_frac{1,i}(j,2))=exp_frac{2,i};
    end
end

for i=1:ff
    n=length(found_frac{1,i});
    for j=1:n
        mat_edge(found_frac{1,i}(j,1),found_frac{1,i}(j,2))=k+i;
    end
end

CMAX=k;
CMIN=0;
plot_marilyn_Statoil(mat_edge,CMIN,CMAX,depth,I);


toc
%% Processing of the regrouped points
%finds the arguments of the best fitting sinusoid
%the fitting might go wrong sometimes and this step should be repeted
n_points_sin=30;
mat_fit=zeros(M,6,k);
mysin=@(Amplitude, Phase, Depth ,x) Amplitude * cos( x-Phase ) + Depth;

kk=0;
matmax=zeros(1,2);
matmin=zeros(1,2);
for i=1:k+ff
    [ifind,jfind] = find(mat_edge(:,:)==i);
    if length( ifind ) >= n_points_sin
        [matmax(1,1),matmax(1,2)]=max(ifind);
        [matmin(1,1),matmin(1,2)]=min(ifind);
        [Amp , Pha , Dep] = find_arg(matmax ,matmin , M);
        sinfit=fit( x(jfind)' , ifind , mysin , 'StartPoint', [Amp,Pha,Dep]);
        kk=kk+1;
        mat_fit(1,1,kk)=length( ifind );
        mat_fit(1:length(ifind) ,2,kk)=ifind;
        mat_fit(1:length(ifind) ,3,kk)=jfind;
        mat_fit(1,4,kk)=sinfit.Amplitude;
        mat_fit(1,5,kk)=sinfit.Phase;
        mat_fit(1,6,kk)=sinfit.Depth;
    end
end
mat_fit(:,:,kk+1:end)=[];
toc

%%
%regroups the points belonging to the same sinusoid together and
%recalculates the arguments of the sinusoid
prec=0.10;
for i=1:kk
    j=i+1;
    while j<kk+1
        if abs((mat_fit(1,4,j)-mat_fit(1,4,i))/mat_fit(1,4,i))<prec...
                && abs((mat_fit(1,5,j)-mat_fit(1,5,i))/mat_fit(1,5,i))<prec...
                && abs((mat_fit(1,6,j)-mat_fit(1,6,i))/mat_fit(1,6,i))<prec
            ifind=vertcat(mat_fit(1:mat_fit(1,1,i),2,i),mat_fit(1:mat_fit(1,1,j),2,j));
            jfind=vertcat(mat_fit(1:mat_fit(1,1,i),3,i),mat_fit(1:mat_fit(1,1,j),3,j));
            mat_fit(1,1,i)=mat_fit(1,1,i)+mat_fit(1,1,j);

            sinfit=fit( x(jfind)' , ifind , mysin , 'StartPoint', [mat_fit(1,4,i),mat_fit(1,5,i),mat_fit(1,6,i)]);
            mat_fit(1:length(ifind) ,2,i)=ifind;
            mat_fit(1:length(ifind) ,3,i)=jfind;
            mat_fit(1,4,i)=sinfit.Amplitude;
            mat_fit(1,5,i)=sinfit.Phase;
            mat_fit(1,6,i)=sinfit.Depth;

            mat_fit(:,:,j)=[];
            j=j-1;
            kk=kk-1;
        end
        j=j+1;
    end
end
toc
%%
mat_std=zeros(N, M);
% removes all the groups containing less than n_points_sin_tot points
n_points_sin_tot=90;
i=1;
while i<kk+1
    if mat_fit(1,1,i)<n_points_sin_tot
        for j=1:mat_fit(1,1,i)
%             mat_std(mat_fit(j,2,i),mat_fit(j,3,i))=1;
        end
        mat_fit(:,:,i)=[];
        i=i-1;
        kk=kk-1;
    end
    i=i+1;
end

%plots in a new matrix the sinusoids found previously
for i=1:kk
    f=mat_fit(1,4,i)*cos(x-mat_fit(1,5,i))+mat_fit(1,6,i);
    for ii=1:M
        if round(f(1,ii))>0 && round(f(1,ii))<=N
            mat_std(round(f(1,ii)),ii)=1;
        end
    end
end
%%
% I=4;
CMAX=2;
CMIN=0;
plot_marilyn_Statoil(mat_std,CMIN,CMAX,depth,I);
toc