function [ temp_para ] = sin_hough( mat_win , x , y , ndef , ncos, Amax)
%Makes a sinusoidal hough transform on mat_win

phi0=-pi:2*pi/ncos:pi;
Apas=Amax/ndef;
phipas=2*pi/ndef;

[Y0,X0]=find(mat_win==1);
x0=x(X0);
y0=y(Y0);
[t,m]=size(x0);

if m~=0||t~=0
    temp_para=zeros(ndef+1,ndef+1,'uint8');
    for i=1:m
        phik=-pi;
        iphik=1;

        % j=1, find the position of the first point
        if (x0(1,i)-phi0(1,1))~=0
            A0=y0(1,i)/(cos(x0(1,i)-phi0(1,1)));
            if A0>=0
                if A0>Amax
                    A0=Amax;
                end
                
                while 1
                    if phik>phi0(1,1)||abs(phik-phi0(1,1))<0.000001
                        j0=iphik;
                        break
                    end
                    iphik=iphik+1;
                    phik=phik+phipas;
                end

                iAk=1;
                Ak=0;
                if A0==0
                        i0=1;
                else
                    while 1
                        if A0<Ak+Apas||abs(A0-Ak-Apas)<0.000001
                            i0=iAk;
                            break
                        end
                        iAk=iAk+1;
                        Ak=Ak+Apas;
                    end
                end
                temp_para(i0,j0)=temp_para(i0,j0)+1;
            else
                iAk=1;
                Ak=0;
            end
        else
            iAk=1;
            Ak=0;
        end
        
        %loop on the other values
        for j=2:ncos+1
            if (x0(1,i)-phi0(1,j))~=0
                
                A0=y0(1,i)/(cos(x0(1,i)-phi0(1,j)));
                if A0>=0
                    if A0>Amax
                        A0=Amax;
                    end
                    
                    while 1
                        if phik>phi0(1,j)||abs(phik-phi0(1,j))<0.000001
                            j0=iphik;
                            break
                        end
                        iphik=iphik+1;
                        phik=phik+phipas;
                    end
                    
                    
                    if Ak<A0&&A0<Ak+Apas||abs(A0-Ak-Apas)<0.000001
                        i0=iAk;
                    else
                        if A0<Ak||abs(A0-Ak)<0.000001
                            while 1
                                if Ak-Apas<A0||abs(A0-Ak)<0.000001
                                    i0=iAk;
                                    break
                                end
                                iAk=iAk-1;
                                Ak=Ak-Apas;
                            end
                        else
                            iAk=iAk+1;
                            Ak=Ak+Apas;
                            while 1
                                if A0<Ak+Apas||abs(A0-Ak-Apas)<0.000001
                                    i0=iAk;
                                    break
                                end
                                iAk=iAk+1;
                                Ak=Ak+Apas;
                            end
                        end
                    end
                    temp_para(i0,j0)=temp_para(i0,j0)+1;
                end
            end
        end
    end
end
end