function [ cell_path_rad ] = find_path( phi_rad , size_win ,n_x_line, n_factor )
%find a path along two points which are symmetrical compared to the center of the matrix
%for different angles

n_phi_rad=length(phi_rad);
n_factor_2=(n_factor-1)/2;

%%find the position of the circle's boundary
win_rad=zeros((2*size_win+1)*n_factor,(2*size_win+1)*n_factor,3);
phi_min=0;
phi_max=0;
x_win_mem=size_win*n_factor+n_factor_2;
y_win_mem=0;
for i=1:n_phi_rad
    x_win_rad=(size_win*n_factor+n_factor_2+0.5)*cos(phi_rad(i));
    y_win_rad=(size_win*n_factor+n_factor_2+0.5)*sin(phi_rad(i));
    
    if x_win_rad>=0
        x_win=size_win*n_factor+n_factor_2;
        while 1
            if x_win_rad>x_win && x_win_rad<x_win+1 || abs(x_win_rad-x_win)<0.000001
                break
            else
                x_win=x_win-1;
            end
        end
    else
        x_win=size_win*n_factor+n_factor_2;
        while 1
            if x_win_rad>x_win && x_win_rad<x_win+1 || abs(x_win_rad-x_win)<0.000001
                break
            else
                x_win=x_win-1;
            end
        end
        x_win=x_win+1;
    end
    y_win=-1;
    while 1
        if y_win_rad<y_win+1 && y_win_rad>y_win ||abs(y_win_rad-y_win-1)<0.000001
            break
        else
            y_win=y_win+1;
        end
    end
    if y_win==-1
        y_win=0;
    end
    if win_rad(size_win*n_factor+n_factor_2+1-y_win,size_win*n_factor+n_factor_2+1+x_win,1)==1
        if phi_rad(i)<phi_min
            phi_min=phi_rad(i);
        end
        if phi_rad(i)>phi_max
            phi_max=phi_rad(i);
        end
    else
        win_rad(size_win*n_factor+n_factor_2+1-y_win_mem,size_win*n_factor+n_factor_2+1+x_win_mem,2)=phi_min;
        win_rad(size_win*n_factor+n_factor_2+1-y_win_mem,size_win*n_factor+n_factor_2+1+x_win_mem,3)=phi_max;
        phi_min=phi_rad(i);
        phi_max=phi_rad(i);
        x_win_mem=x_win;
        y_win_mem=y_win;
    end
    if phi_rad(i)==pi
        win_rad(size_win*n_factor+n_factor_2+1-y_win_mem,size_win*n_factor+n_factor_2+1+x_win_mem,2)=phi_min;
        win_rad(size_win*n_factor+n_factor_2+1-y_win_mem,size_win*n_factor+n_factor_2+1+x_win_mem,3)=phi_max;
    end
    win_rad(size_win*n_factor+n_factor_2+1-y_win,size_win*n_factor+n_factor_2+1+x_win,1)=1;
end

temp_coor_rad=find(win_rad(:,:,1)==1);
n_coor_rad=length(temp_coor_rad);
coor_rad=zeros(n_coor_rad,2);
[coor_rad(:,2),coor_rad(:,1)]=find(win_rad(:,:,1)==1);


%%find the symmetric of the points defined in the upper part of win_rad
%and find all the matrix cell crossed by a line joining the two cells
cell_path_rad=cell(2,n_coor_rad-1);
for i=1:n_coor_rad
    x1=coor_rad(i,1)-0.5;
    y1=coor_rad(i,2)-0.5;
    x2=((2*size_win+1)*n_factor+1-coor_rad(i,1))-0.5;
    y2=((2*size_win+1)*n_factor+1-coor_rad(i,2))-0.5;
    
    if x1~=(2*size_win+1)*n_factor-0.5 || y1~=size_win*n_factor+n_factor_2+0.5
        if x1~=x2
            m_coeff=(y2-y1)/(x2-x1);
            y0=y1-m_coeff*x1;

            x_line=linspace(x1,x2,n_x_line);
            y_line=m_coeff*x_line+y0;

            ii=coor_rad(i,2)-1;
            jj=coor_rad(i,1)-1;
            n_path=1;
            temp_cell_path_rad=zeros(3*size_win*n_factor+1,2);
            temp_cell_path_rad(n_path,1)=ii;
            temp_cell_path_rad(n_path,2)=jj;
            if x2>x1
                for j=1:n_x_line
                    while 1
                        if x_line(j)<=jj+1
                            break
                        else
                            jj=jj+1;
                        end
                    end
                    while 1
                        if y_line(j)<=ii+1
                            break
                        else
                            ii=ii+1;
                        end
                    end

                    if ii~=temp_cell_path_rad(n_path,1) || jj~=temp_cell_path_rad(n_path,2)
                        n_path=n_path+1;
                        temp_cell_path_rad(n_path,1)=ii;
                        temp_cell_path_rad(n_path,2)=jj;
                    end
                end
            else
                for j=1:n_x_line
                    while 1
                        if x_line(j)>=jj
                            break
                        else
                            jj=jj-1;
                        end
                    end
                    while 1
                        if y_line(j)<=ii+1
                            break
                        else
                            ii=ii+1;
                        end
                    end

                    if ii~=temp_cell_path_rad(n_path,1) || jj~=temp_cell_path_rad(n_path,2)
                        n_path=n_path+1;
                        temp_cell_path_rad(n_path,1)=ii;
                        temp_cell_path_rad(n_path,2)=jj;
                    end
                end
            end
            temp_cell_path_rad=temp_cell_path_rad+1;
            temp_cell_path_rad(n_path+1:end,:)=[];
        else
            temp_cell_path_rad=zeros(3*size_win*n_factor+1,2);
            for j=1:(2*size_win+1)*n_factor
                temp_cell_path_rad(j,1)=j;
                temp_cell_path_rad(j,2)=coor_rad(i,1);
            end
            temp_cell_path_rad((2*size_win+1)*n_factor+1:end,:)=[];
        end
        cell_path_rad{1,i}=sub2ind(size(win_rad(:,:,1)),temp_cell_path_rad(:,1),temp_cell_path_rad(:,2));
        cell_path_rad{2,i}(1,1)=win_rad(coor_rad(i,2),coor_rad(i,1),2);
        cell_path_rad{2,i}(2,1)=win_rad(coor_rad(i,2),coor_rad(i,1),3);
        cell_path_rad{2,i}(3,1)=(cell_path_rad{2,i}(2,1)+cell_path_rad{2,i}(1,1))/2;
        if cell_path_rad{2,i}(3,1)>pi/2
            cell_path_rad{2,i}(3,1)=cell_path_rad{2,i}(3,1)-pi;
        end
    end
end